import os
import sys
lang1 = [LANG1]
lang2 = [LANG2]
gpuid = [GPU ID]
train_size = [TRAIN DICT SIZE]
DIR_NEW = [DIR OF C2 TRAINING DICT]
output_dir = [DIR FOR SAVING BERT MODEL]
train_dir = [DIR FOR C2 TRAINING POS/NEG PAIRS]
l1_voc = [LANG1 VOCABULARY DIR]
L1_EMB = [C1 ALIENGED EMB FOR LANG1 DIR]
l2_voc = [LANG2 VOCABULARY DIR]
L2_EMB = [C1 ALIENGED EMB FOR LANG2 DIR]
DIR_TEST_DICT = [BLI TEST DICT DIR]
DIR_TRAIN_DICT = [BLI TRAIN DICT DIR]
random_seed = [RANDOM SEED]



#Hyper-parameters to reproduce our results.
model_dir = "bert-base-multilingual-uncased"
epoch = 5
train_batch_size = 100
learning_rate = 2e-5
max_length = 6
checkpoint_step = 9999999
random_seed = 33
infoNCE_tau = 0.1
agg_mode = "cls"
num_neg = 28
num_iter = 1
template = 0
neg_max = 60000 


print(lang1, lang2)
sys.stdout.flush()

print("GEN NEG SAMPLES")
os.system('CUDA_VISIBLE_DEVICES={} python gen_neg_samples.py --l1 {} --l2 {} --train_size {} --root {} --num_neg {} --neg_max {} --l1_voc {} --l1_emb {} --l2_voc {} --l2_emb {} --train_dict_dir {} --test_dict_dir {}'.format(gpuid,lang1, lang2, train_size, DIR_NEW, num_neg, neg_max, l1_voc, l1_emb, l2_voc, l2_emb, DIR_TRAIN_DICT, DIR_TEST_DICT))

print("C2 Contrastive TRAINING") 
os.system("CUDA_VISIBLE_DEVICES={} python3 train.py --model_dir {} --train_dir {} --output_dir {} --l1 {} --l2 {} --l1_voc {} --l1_emb {} --l2_voc {} --l2_emb {} --use_cuda --epoch {} --train_batch_size {} --learning_rate {} --max_length {} --checkpoint_step {} --parallel --amp --random_seed {} --infoNCE_tau {} --random_erase 0 --dropout_rate 0.1 --agg_mode {} --num_neg {} --template {} --random_seed {}".format(gpuid, model_dir, train_dir, output_dir, lang1, lang2, l1_voc, l1_emb, l2_voc, l2_emb, epoch, train_batch_size, learning_rate, max_length, checkpoint_step, random_seed, infoNCE_tau, agg_mode, num_neg, template, random_seed))


print("EVALUATION") 
os.system("CUDA_VISIBLE_DEVICES={} python evaluate_bli_procrustes.py --l1 {} --l2 {} --train_size {} --root {} --model_name {} --agg_mode {} --template {} --max_length {} --l1_voc {} --l1_emb {} --l2_voc {} --l2_emb {} --train_dict_dir {} --test_dict_dir {}".format(gpuid, lang1, lang2, train_size, DIR_NEW, output_dir, agg_mode, template, max_length,l1_voc, l1_emb, l2_voc, l2_emb, DIR_TRAIN_DICT, DIR_TEST_DICT))

